package com.example.ellegadodepintia

import android.content.Intent
import android.os.Bundle
import android.widget.ImageButton
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import com.example.ellegadodepintia.exploradoresDePintia.ModalConfirmacion
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.soundManager.SoundManager

class TabernaActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_taberna)

        GameState.jugador.addObserver { actualizarNivelTaberna() }
        val mapButton: ImageButton = findViewById(R.id.mapButton)
        val botonMejorar = findViewById<TextView>(R.id.botonMejorar)
        val textoInformacion = findViewById<TextView>(R.id.textoInformacion)

        actualizarNivelTaberna()
        mapButton.setOnClickListener{
            super.onBackPressed()
        }
        botonMejorar.setOnClickListener {
            val confirmacionFragment = ModalConfirmacion()
            var soundManager: SoundManager
            soundManager = SoundManager(this)
            confirmacionFragment.onDismissListener = { mejorar ->
                if (mejorar) {
                    "Se ha realizado la mejora con éxito".also { textoInformacion.text = it }
                    soundManager.playSound(R.raw.sound_dineros,100)
                } else {
                    "No se ha podido realizar la mejora".also { textoInformacion.text = it }
                }
            }
            confirmacionFragment.show(supportFragmentManager, "confirmacion")
        }
    }

    private fun actualizarNivelTaberna() {
        val textoNivel = findViewById<TextView>(R.id.nivelActual)
        "Nivel actual: ${GameState.jugador.nivelCiudad}".also { textoNivel.text = it }

    }
}
