package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.graphics.drawable.AnimationDrawable
import android.os.Handler
import android.os.Looper
import android.widget.ImageView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GeneradorDeEventos
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.ObjetoDeValor
import com.example.ellegadodepintia.repositorios.RepositorioObjetos
import com.example.ellegadodepintia.soundManager.SoundManager
//TODO() Agregar inventario con restos de la reliquia
class EfectoDestruir(probabilidadExito: Int) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        soundManager = SoundManager(context!!)
        val probabilidad = (1..100).random()
        return if (probabilidad <= probabilidadExito) {
            val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)

            imagenProtagonista?.setImageResource(R.drawable.protagonista_ataque_animation)
            val ataqueAnimation = imagenProtagonista?.drawable as? AnimationDrawable
            ataqueAnimation?.start()
            soundManager.playSound(R.raw.sound_espada,100)

            Handler(Looper.getMainLooper()).postDelayed({
                imagenProtagonista?.setImageResource(R.drawable.protagonista_idle_animation)
                val idleAnimation = imagenProtagonista?.drawable as? AnimationDrawable
                idleAnimation?.start()
            }, 750)

            val ataque = GameState.jugador.atributos[Atributo.Ataque]!!
            GameState.eventoActual.actualizarResistencia(-ataque)

            if (GameState.eventoActual.resistenciaActual > 0) {
                "¡Cuidado, parece que la reliquia se está quebrando!"
            } else {
                GameState.eventoActual.actualizarFinalizado(true)
                GameState.jugador.conseguirObjeto(
                    RepositorioObjetos.obtenerObjetoPorNombre("Fragmento de reliquia")!!
                )
                val probabilidadCombate = (0..1).random()
                soundManager.playSound(R.raw.sound_romper,100)
                if(probabilidadCombate <= 60){
                    GeneradorDeEventos.insertarCombate()
                    "¡Qué has hecho, la reliquia se ha roto por completo!. Has conseguido un fragmento de la reliquia. Parece que un enemigo te ha visto, ¡el próximo evento será un combate!"
                }else{
                    "¡Qué has hecho, la reliquia se ha roto por completo!. Has conseguido un fragmento de la reliquia"
                }
            }
        } else {
            "La reliquia ha resistido el golpe con éxito."
        }
    }
}
