package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.animation.ObjectAnimator
import android.graphics.drawable.AnimationDrawable
import android.os.Handler
import android.os.Looper
import android.widget.ImageView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.ModalDetallesEnemigo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.soundManager.SoundManager


class EfectoInvestigarEnemigo(probabilidadExito: Int) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        soundManager = SoundManager(GameState.context!!)
        val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)
        val imagenEfecto = context!!.findViewById<ImageView>(R.id.imagenEfectoEvento)

        imagenProtagonista?.let {
            val salto = ObjectAnimator.ofFloat(it, "translationY", 0f, -40f, 0f)
            salto.duration = 300
            salto.start()
            soundManager.playSound(R.raw.sound_laser,100)
            Handler(Looper.getMainLooper()).postDelayed({
                imagenEfecto?.setImageResource(R.drawable.effect_investigar_animation)
                val efectoAnimacion = imagenEfecto?.drawable as? AnimationDrawable
                efectoAnimacion?.start()
                Handler(Looper.getMainLooper()).postDelayed({
                    imagenEfecto?.setImageDrawable(null)
                }, 400)
            }, 300)
        }
        val modalDetallesFragment = ModalDetallesEnemigo()
        modalDetallesFragment.show(GameState.fragmentManager, "modalDetalles")

        return "Has investigado al enemigo"
    }
}
